// Output generated from file: D:/programs install/fraclal generators/Fragmentarium-anim/Examples/a_surf_color.frag
// Created:  1.  20:38:59 2015
#info Amazing Surface by Kali - Based on Tglad's Amazing Box
#define providesInit
#include "ColorPalette.frag"
#include "MathUtils.frag"
#include "DE-Raytracer.frag"



#group AmazingSurface


uniform int Iterations;  slider[0,17,300]
uniform int ColorIterations;  slider[0,3,300]
uniform float MinRad2;  slider[0.00001,0.25,2.0]
uniform float Scale;  slider[-3,1.5,3.0]
uniform int FoldType; slider[1,1,3]
uniform vec3 PreTranslation; slider[(-5,-5,-5),(0,0,0),(5,5,5)]
uniform vec2 FoldValues; slider[(0,0),(1,1),(5,5)]
uniform bool Julia; checkbox[false]
uniform vec3 JuliaValues; slider[(-5,-5,-5),(-1,-1,-1),(5,5,5)]
uniform vec3 RotVector; slider[(-1,-1,-1),(1,1,1),(1,1,1)]
uniform float RotAngle; slider[-180,0,180]
uniform float time;

mat3 rot;

void init() {
	 rot = rotationMatrix3(normalize(RotVector), RotAngle);
}

vec4 scale = vec4(Scale, Scale, Scale, abs(Scale));
float absScalem1 = abs(1-Scale);
float AbsScaleRaisedTo1mIters = pow(abs(Scale), float(1-Iterations));

float DE(vec3 pos) {
	vec4 p = vec4(pos,1);
	vec4 c = Julia?vec4(JuliaValues,1):p;  
	for (int i=0; i<Iterations; i++) {
		if (FoldType==1) p.xy=abs(p.xy+FoldValues)-abs(p.xy-FoldValues)-p.xy;
		if (FoldType==2) p.xy=FoldValues-abs(abs(p.xy)-FoldValues);
		if (FoldType==3) p.xy=abs(p.xy+FoldValues);
		p.xyz+=PreTranslation;
		float r2 = dot(p.xyz, p.xyz);
		//if (i<ColorIterations) orbitTrap = min(orbitTrap, abs(vec4(p.xyz,r2)));
		p*= scale/clamp(r2,MinRad2,1.0);
		p+=c;
		p.xyz*=rot;
	}
	return ((length(p.xyz) - absScalem1) / p.w - AbsScaleRaisedTo1mIters);
}

float Coloring(vec3 p) {

	float expsmooth=0.0;
	float r1 = 0.0, r2 = 0.0;

	for (int i=0; i<ColorIterations; i++) {

		if (FoldType==1) { p.xy=abs(p.xy+FoldValues)-abs(p.xy-FoldValues)-p.xy;
		r1 = r2;
		r2 = dot(p, p); }
		if (FoldType==2){  p.xy=FoldValues-abs(abs(p.xy)-FoldValues);
		r1 = r2;
		r2 = dot(p, p);}
		if (FoldType==3){  p.xy=abs(p.xy+FoldValues);
		r1 = r2;
		r2 = dot(p, p);}
		p.xyz+=PreTranslation;
		//float r2 = dot(p.xyz, p.xyz);
		p*=rot;	
		r1 = r2;
		r2 = dot(p, p);
		p=abs(p)+PreTranslation;
		r1 = r2;
		r2 = dot(p, p);
		p*= scale/clamp(r2,MinRad2,1.0);
		r1 = r2;
		r2 = dot(p, p);
		p+=JuliaValues;

		p.xyz*=rot;
r2 = dot(p, p);
		expsmooth+=exp(-1.0/abs(r1-r2));	
	}

	return expsmooth;
}

/*float DE(vec3 pos) {
return min(DE1(pos), surf(pos));
}
*/























#preset default
Color1 = 0.635294,0.721569,1
Color2 = 1,0.686275,0.184314
Color3 = 0.282353,1,0.172549
ColorDensity = 0.8
ColorOffset = 0
FOV = 0.4
Eye = 3.64993,0.656286,-1.88282
Target = -3.31007,-0.580438,5.19028
Gamma = 1.5
ToneMapping = 5
Exposure = 1
Brightness = 1
Contrast = 1
Saturation = 1
GaussianWeight = 1
AntiAliasScale = 2
Detail = -4.3
FudgeFactor = 1
Dither = 1
NormalBackStep = 1
AO = 0,0,0,1
CamLight = 0.592157,0.721569,0.776471,1
CamLightMin = 1
BaseColor = 1,1,1
OrbitStrength = 1
X = 0.5,0.6,0.6,1
Y = 1,0.6,0,0.4
Z = 0.8,0.78,1,0.5
R = 0.4,0.7,1,0.12
BackgroundColor = 0.454902,0.568627,0.6
GradientBackground = 0
CycleColors = false
Cycles = 1.1
EnableFloor = false
FloorNormal = 0,0,1
FloorHeight = 0
FloorColor = 1,1,1
Iterations = 14
ColorIterations = 20
MinRad2 = 1e-05
Scale = 1.5273
FoldType = 3
PreTranslation = 0,-0.1471,-0.1471
FoldValues = 0,0
Julia = true
JuliaValues = -0.3571,-0.9524,-0.9524
RotVector = 1,-1,0
RotAngle = 11.394
Glow = 1,1,1,0
GlowMax = 20
EquiRectangular = false
FocalPlane = 1
Aperture = 0
DetailAO = -0.22337
MaxRaySteps = 1092
Specular = 0
SpecularExp = 16
SpecularMax = 10
SpotLight = 1,1,1,1
SpotLightDir = -0.76624,1
Fog = 0
HardShadow = 0.62821 NotLocked
ShadowSoft = 2.6666
Reflection = 0 NotLocked
DebugSun = false
Up = -0.697276,-0.118769,-0.706894
#endpreset

